/*
  eep_srec.c
  EEPROMS-recordեǼ롼
 */

#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <mon_func.h>
#include "mon_defs.h"

struct eeprom_header{
    char flag;
    char type;
    char comment[64];
    int size,lz_size,h_size;
};

static int getsrec(char *memptr,int limit)
{
    char *sptr;
    int outcount=0,len;

    sptr=memptr;

    for(;;)
    {
        hgetstr_no_echo(memptr);
        if(memptr[0] == 0x1b){
            hputstr("aborted...\r\n");
            return -1;
        }

        if(memptr[0] != 'S'){
            hputstr(memptr);
            hputstr("Invalid S-record file.\r\n"
                    "Aborted...\r\n");
            return -1;
        }
        len = strlen(memptr);
        outcount += len+1;
        memptr[len]='\r';

        if( memptr[1]=='8' || memptr[1]=='9'){
            hprintf("Loaded S-record file.\n\r"
                    " start addr : 0x%A\n\r"
                    " size       : %d byte\n\r",sptr,outcount);
            return outcount;
        }
        if( outcount >= (limit-40) ){
            hputstr("Too large S-record file.\r\n"
                    "Aborted...\r\n");
            return -1;
        }
        memptr += len+1;
    }
}

static int locate_srec(char *buf)
{
    char file_name[FILE_NAME_BUFFER_SIZE] = ""; /* ե͡Ǽΰ */
    unsigned char linebuf[LINE_BUFFER_SIZE];    /* ʬΥǡǼΰ */
    unsigned char bytes;        /* Ԥ˴ޤޤǡΥХȿ */
    unsigned int linesum;       /* å */

    unsigned char *memptr;      /* ǡžѥݥ */

    char *str; /* ԤǼХåե */
    int i;
    unsigned int sum_bytes = 0; /* ǡХȿ */

    while (1) {

        str=buf;
        while(*buf != '\r') buf++;
        *buf='\0';
        buf++;

	if (str[0] == 'S') {	/* ХܤS */
	    /* ХܤϣԤΥǡΥХȿ */
	    bytes =((str[2] >='A') ? (str[2] + 10 - 'A') : (str[2] - '0')) << 4;
	    bytes |=((str[3] >= 'A') ? (str[3] + 10 - 'A') : (str[3] - '0'));

	    sum_bytes += bytes;
	    linesum = bytes;

	    for (i = 1; i <= bytes; i++) {
		linebuf[i] =
		    ((str[2 * i + 2] >= 'A') ? (str[2 * i + 2] + 10 - 'A') : (str[2 * i +2] -'0')) << 4;
		linebuf[i] |=
		    ((str[2 * i + 3] >= 'A') ? (str[2 * i + 3] + 10 - 'A') : (str[2 * i +3] - '0'));
		linesum += linebuf[i];
	    }

	    /* åȹ */

	    if ((linesum & 0xff) != 0xff) {
		hputstr("*** Checksum ERROR *** \n\r");
		return -1;
	    }

	    switch (str[1]) {	/* Хܤޥ */
	    case '0':		/*ե͡ */
		for (i = 3; i < bytes; i++)
		    file_name[i - 3] = linebuf[i];
		file_name[++i] = '\0';
		break;

	    case '1':		/* ɥ쥹16Bitл */
		memptr =(unsigned char *) ((((unsigned long) (linebuf[1])) << 8)
                                           |((unsigned long) (linebuf[2])));

		for (i = 3; i < bytes; i++)
		    *(memptr + i - 3) = linebuf[i];
		break;

	    case '2':		/* ɥ쥹24Bitл */
		memptr =
		    (unsigned char*) ((((unsigned long) (linebuf[1])) << 16)
                                      |(((unsigned long) (linebuf[2])) << 8)
                                      |((unsigned long) (linebuf[3])));

		for (i = 4; i < bytes; i++) {
		    *(memptr + i - 4) = linebuf[i];
		}
		break;

	    case '8':		/* 24bitлΥץ೫ϥɥ쥹 */
		loaded_main =
		    (void *) ((((unsigned long) (linebuf[1])) << 16)
			      |(((unsigned long) (linebuf[2])) << 8)
			      |((unsigned long) (linebuf[3])));
		hprintf("Filename      : %s \n\r", file_name);
		hprintf("Data size     : %l Bytes\n\r", (long) sum_bytes);
		hprintf("Start Address : 0x%A \r\n", (long) loaded_main);
		return 0;

	    case '9':		/* 16bitлΥץ೫ϥɥ쥹 */
		loaded_main = (void *) (((unsigned long) (linebuf[1]) << 8)
					|(unsigned long) (linebuf[2]));
		hprintf("Filename      : %s \n\r", file_name);
		hprintf("Data size     : %l Bytes\n\r", (long) sum_bytes);
		hprintf("Start Address : 0x%A \r\n", (long) loaded_main);
		return 0;

	    default:
		break;
	    }
	} else {
	    hputstr("*** Invalid Data *** \n\r");
	}
    }
}

int eep_writesrec()
{
    if(mon_has_eeprom==0){
        hputstr("eeprom is disabled.\r\n");
        return -1;
    }else{
        struct eeprom_header eehead;

        int size,lz_size,h_size;
        char *sptr=(char *)0x400100,*cptr;

        hputstr("Please send S-record(.mot) file.\r\n"
                "(press [ESC] to abort.)\r\n");
        size = getsrec(sptr,0x100000);
        if(size<0){
            return -1;
        }

        cptr = sptr + size;
        hputstr("deflating by lz.c ... \r\n");
        lz_size = lz_encode(sptr,size,cptr,(char *)0x5fffff - cptr);
        if(lz_size<0){
            hputstr("Aborted...\r\n");
            return -1;
        }
        hprintf("deflating ratio %d%%\r\n",lz_size*100/size);
        memmove(sptr,cptr,lz_size);
        cptr=sptr+lz_size;
        hputstr("deflating by huffman.c ... \r\n");    
        h_size = huffman_encode(sptr,lz_size,cptr,(char *)0x5fffff - cptr);
        if(h_size<0){
            hputstr("Aborted...\r\n");
            return -1;
        }
        hprintf("deflating ratio %d%%\r\n",h_size*100/lz_size);
        hprintf("total deflating ratio: %d%%\r\n",h_size*100/size);
        hprintf("In: %d byte  Out: %d byte\r\n",size,h_size);

        hputstr("writing compressed data.\r\n");

        eehead.flag=0;
        eehead.type=0;              /* ǡ */
        strcpy(eehead.comment,"compressed srec data"); /* ǡΥ */
        eehead.size=size; /* ǡ */
        eehead.lz_size=lz_size;
        eehead.h_size=h_size;

        /* إåν񤭹 */
        eep_write_bytes(0,sizeof(struct eeprom_header),(char *)&eehead);
        /* ̥ǡν񤭹*/
        eep_write_bytes(sizeof(struct eeprom_header), h_size, cptr);
        hputstr("done.\r\n");
        return 0;
    }
}

/* ǡŸ */ 
int eep_readsrec()
{
    if(mon_has_eeprom==0){
        hputstr("eeprom is disabled.\r\n");
        return -1;
    }else{
        struct eeprom_header eehead;

        char *sptr=(char *)0x400100;

        hputstr("reading S-record file from eeprom...\r\n");

        eep_read_bytes(0,sizeof(struct eeprom_header),(char *)&eehead);
        eep_read_bytes(sizeof(struct eeprom_header), eehead.h_size, sptr);

        if(strcmp(eehead.comment,"compressed srec data") != 0
           || eehead.type != 0){
            hputstr("Not srec data...\r\naborted\r\n");
            return -1;
        }

        hputstr("Huffman inflating....");
        huffman_decode(sptr,eehead.lz_size,sptr+eehead.h_size);
        hputstr("done.\r\n");
        memmove(sptr,sptr+eehead.h_size,eehead.lz_size);
        hputstr("LZ inflating....");
        lz_decode(sptr,eehead.size,(char *)0x600000 - eehead.size);
        hputstr("done.\r\n");
        locate_srec((char *)0x600000 - eehead.size);
        return 0;
    }
}
