/*
  2EEPROM(AT24C1024)Ȥ
  P9-4: SCL
  P9-5: SDA
  
  EEPROMǽϥǥեȤǤ̵Ƥ롣ͭϡ
  const int mon_has_eeprom=0;
             
  const int mon_has_eeprom=1;
  Τ褦˲Ƥmon_has_eepromͤ񤭴衣

  Version 1.2Version 1.2.1ؤѹǻѥݡȤ
  PORT4.B3PORT9.B5
  PORT4.B2PORT9.B4
  Ȥʤä
*/

#include <stdlib.h>
#include <ctype.h>

#include <3069S.H>
#include <mon_func.h>

#define EEP_SDA P9DR.BIT.B5
#define EEP_SCL P9DR.BIT.B4

const int mon_has_eeprom = 0;   /* 0:EEPROMʤ 1:EEPROM */

#define data_output() {                                         \
    P9DDR = 0x30;    /*SCL(P94) is output. SDA(P95) is output*/ \
}

#define data_input() {                                          \
    P9DDR = 0x10;   /*SCL(P94) is output. SDA(P95) is input*/   \
}

#define t_WR 10000
#define EEP_A1 0

/*
  Ԥ롼
  NOPˤϣơȤפ
  1u=12.5state(@25MHz)
 */

#define WAIT_T_LOW __asm__ volatile ("\tnop\n"  \
                                     "\tnop\n"  \
                                     "\tnop\n"  \
                                     "\tnop\n"  \
                                     "\tnop\n"  \
                                     "\tnop\n"  \
                                     "\tnop\n")

#define WAIT_T_BUF __asm__ volatile ("\tnop\n"  \
                                     "\tnop\n"  \
                                     "\tnop\n"  \
                                     "\tnop\n"  \
                                     "\tnop\n"  \
                                     "\tnop\n"  \
                                     "\tnop\n")

#define WAIT_T_HIGH __asm__ volatile("\tnop\n"  \
                                     "\tnop\n"  \
                                     "\tnop\n"  \
                                     "\tnop\n"  \
                                     "\tnop\n")
                                     
#define WAIT_T_HD_STA __asm__ volatile("\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n")
                   
#define WAIT_T_SU_STA __asm__ volatile("\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n")

#define WAIT_T_HD_DAT __asm__ volatile("\tnop\n")
                   
#define WAIT_T_SU_DAT __asm__ volatile("\tnop\n"        \
                                       "\tnop\n")

#define WAIT_T_SU_STO __asm__ volatile("\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n")
                  
#define WAIT_1US     __asm__ volatile ("\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n"        \
                                       "\tnop\n")

inline static void eep_stop()
{
    data_output();
    EEP_SDA = 0;
    EEP_SCL = 1;
    WAIT_T_SU_STO;
    EEP_SDA = 1;
    WAIT_T_BUF;
    EEP_SCL = 0;
}

inline static void eep_start()
{
    data_output();
    EEP_SDA = 1;
    EEP_SCL = 1;
    WAIT_T_SU_STA;
    EEP_SDA = 0;
    WAIT_T_HD_STA;
    EEP_SCL = 0;
}

inline static void send_0(void)
{
    EEP_SCL = 0;
    data_output();
    EEP_SDA = 0;
    WAIT_T_SU_DAT;
    EEP_SCL = 1;
    WAIT_T_HD_DAT;
    EEP_SCL = 0;
}

inline static void send_1(void) {
    EEP_SCL = 0;
    data_output();
    EEP_SDA = 1;
    WAIT_T_SU_DAT;
    EEP_SCL = 1;
    WAIT_T_HD_DAT;
    EEP_SCL = 0;
}

inline static void send_bits(unsigned int bits, unsigned char data)
{
    unsigned char mask;
    for(mask = 1 << (bits-1); mask; mask >>= 1) {
        if(data & mask) send_1(); else send_0();
    }
}

inline static void send_byte(unsigned char data)
{
    unsigned char mask;
    for(mask = 0x80; mask; mask >>= 1) {
        if(data & mask) send_1(); else send_0();
    }
}

inline static void wait_ack()
{
    data_input();
    WAIT_1US;
    EEP_SCL = 1;
    while(EEP_SDA != 0);
    EEP_SCL = 0;
}

inline static void eep_address(unsigned long int address)
{
    // 10100 A_1 P_0 R/~W
    /* dummy write */
    eep_start();
    send_bits(5, 0x14); //10100
    if(address & 0x20000) send_1(); else send_0(); //A_1
    if(address & 0x10000) send_1(); else send_0(); //P_0
    send_0(); //WRITE
    wait_ack();
    send_byte((address & 0x0ff00) >> 8);
    wait_ack();
    send_byte(address & 0x000ff);
    wait_ack();
}

int eep_write_byte(unsigned long int address, unsigned char data)
{
    if(mon_has_eeprom==0){
        hprintf( __FILE__ ":%d: "
                "Though eeprom is disabled,eep_byte_write() is called.\r\n",__LINE__);
        return -1;
    }else{
        eep_address(address);
        send_byte(data);
        wait_ack();
        eep_stop();
        wait_usec(t_WR);
        return 0;
    }
}


unsigned char eep_read_byte(unsigned long int address)
{
    if(mon_has_eeprom==0){
        hprintf( __FILE__ ":%d: "
                "Though eeprom is disabled,eep_byte_read() is called.\r\n",__LINE__);
        return 0;
    }else{
        int i;
        int p_0;
        int a_1;
        unsigned char data;
        eep_address(address); // dummy write
        /* another START condition to read data */
        eep_start();
	
        p_0 = address & 0x10000 ? 1 : 0;
        a_1 = address & 0x20000 ? 1 : 0;

        send_byte(0x14 << 3 | a_1 << 2 | p_0 << 1 | 1); // read
        wait_ack();
        data = 0;
        data_input();
        for(i = 0; i < 8; i++) {
            data <<= 1;
            EEP_SCL = 1;
            WAIT_T_HIGH;
            data |= EEP_SDA;
            EEP_SCL = 0;
            WAIT_T_LOW;
        }
        eep_stop();
        return data;
    }
}

static void eep_page_write(unsigned long int address, int size, unsigned char *buf)
{
    eep_address(address);
    for(;size > 0; size--) {
        send_byte(*buf++);
        wait_ack();
    }
    eep_stop();
    wait_usec(t_WR);
}

void eep_write_bytes(unsigned long int address, int size, unsigned char *buf)
{
    if(mon_has_eeprom==0){
        hprintf( __FILE__ ":%d: "
                "Though eeprom is disabled,eep_write_bytes() is called.\r\n",__LINE__);
    }else{
        int len;    
        for(;;){
            len = 256 - (address & 0x0ff); /* Ϣ³񤭹߲ǽХȿ */

            if(len < size){
                eep_page_write(address,len,buf);
                buf += len;
                address += len;
                size -= len;
            }else{
                eep_page_write(address,size,buf);
                break;
            }
        }
    }
}

void eep_read_bytes(unsigned long int address, int size, unsigned char *buf)
{
    if(mon_has_eeprom==0){
        hprintf( __FILE__ ":%d: "
                "Though eeprom is disabled,eep_read_bytes() is called.\r\n",__LINE__);
    }else{
        int i;
        int p_0,a_1;
        eep_address(address);
        /* another START condition to read data */
        eep_start();
	
        p_0 = address & 0x10000 ? 1 : 0;
        a_1 = address & 0x20000 ? 1 : 0;
        send_byte(0x14 << 3 | a_1 << 2 | p_0 << 1 | 1); // read
        wait_ack();
        for(; size > 0; size--) {
            unsigned char data = 0;
            data_input();
            for(i = 0; i < 8; i++) {
                data <<= 1;
                EEP_SCL = 1;
                WAIT_T_HIGH;
                data |= EEP_SDA;
                EEP_SCL = 0;
                WAIT_T_LOW;
            }
            if(size != 1) send_0();
            *buf++ = data;
        }
        eep_stop();
    }
}
