/*
  log.c
  VAʐMgȂ̑ւƂăO@\B
 */

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>

#include <mon_func.h>

#define MINIMUM_BUFFER_SIZE 128 /* Oi[obt@TCỶ */

void log_putstr(const char *s);

extern char *monitor_log_buf;
static int size=0,cur=0;

void log_putc(char c)
{
    if(size <= 0) return;

    int_disable();              /* Փ˂̖h~ׁ̈A荞݂֎~B */
    cur++;
    if(cur>=size){
        if(size<MINIMUM_BUFFER_SIZE){
            cur--;
        }else{
            cur=0;
            log_putstr("MONITOR ERROR(log.c): buffer overflow\r\n");
        }
    }else{
        *(monitor_log_buf+cur) = '\0';
        *(monitor_log_buf+cur - 1) = c;
    }
    int_enable();
}

void log_set_mem(char *ptr,int s)
{
    if( s < MINIMUM_BUFFER_SIZE){
        hprintf("MONITOR ERROR(log.c): buffer size must be larger than %d bytes.\r\n"
                ,MINIMUM_BUFFER_SIZE);
        return;
    }
    size = s;
    monitor_log_buf = ptr;
    cur=0;
    *monitor_log_buf = '\0';
}

void log_putstr(const char *s)
{
    while (*s != '\0') {
	log_putc(*s);
	s++;
    }
}

static void log_print_data(unsigned char uc)
{				/* ucQPUiŕ\ */
    char c;

    c = (uc & 0xf0) >> 4;

    if (c >= 10) {
	log_putc('a' + c - 10);
    } else {
	log_putc('0' + c);
    }

    c = uc & 0x0f;

    if (c >= 10) {
	log_putc('a' + c - 10);
    } else {
	log_putc('0' + c);
    }
}

static void log_print_addr(unsigned long l)
{				/* lUPUiŕ\ */
    int i;
    char c;
    unsigned long m = 0xf00000;

    for (i = 5; i >= 0; i--) {
	c = (l & m) >> (i * 4);

	if (c >= 10) {
	    log_putc('a' + c - 10);
	} else {
	    log_putc('0' + c);
	}

	m = m >> 4;
    }
}

static void log_printd(long n)
{				/* n\iŕ\ */
    if (n < 0) {
	log_putc('-');
	n = -n;
    }

    if (n / 10)
	log_printd(n / 10);
    log_putc(n % 10 + '0');
}

void log_printf(char *fmt, ...)
{				/* ȈՔ printf */
    va_list ap;
    char *p, *sval;
    int ival;
    char cval;
    long lval;
    unsigned long ulval;

    va_start(ap, fmt);

    for (p = fmt; *p; p++) {
	if (*p != '%') {
	    log_putc(*p);
	    continue;
	}

	switch (*++p) {
	case 'd':		/* int^  */
	    ival = va_arg(ap, int);
	    log_printd((long) ival);
	    break;

	case 'l':		/* long^  */
	    lval = va_arg(ap, long);
	    log_printd(lval);
	    break;

	case 's':		/* char *^  */
	    for (sval = va_arg(ap, char *); *sval; sval++)
		log_putc(*sval);
	    break;

	case 'c':		/* char^ ꕶ */
	    ival = va_arg(ap, int);
	    cval = isprint((char) ival) ? (char) ival : '.';
	    log_putc(cval);
	    break;

	case 'A':		/* unsigned long^ AhXpUPUi */
	    ulval = va_arg(ap, unsigned long);
	    log_print_addr(ulval);
	    break;

	case 'B':		/* unsigned char^ f[^pQPUi */
	    ival = va_arg(ap, int);
	    log_print_data((unsigned char) ival);
	    break;

	default:
	    log_putc(*p);
	    break;
	}
    }
    va_end(ap);
}

void log_view()
{
    hputstr(monitor_log_buf);
}
