/*
  monitor.c
  H8pj^[̖{  
*/

#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>

#include <string.h>

#include "mon_defs.h"
#include <mon_func.h>
#include "cmd_write_mem.h"
#include "cmd_dump.h"
#include "cmd_load_srec.h"
#include "cmd_help.h"
#include "cmd_version.h"
#include "cmd_go.h"
#include "cmd_checksum.h"
#include "cmd_eeprom.h"

int monitor_inmon = MONITOR_MAGIC_NUMBER; 
/* j^sȂ}WbNio[A[U[vOs͂O */

static void monitor_main()
{
    char str[PROMPT_BUFFER_SIZE] = "";
    char *p;
    size_t len;

    hputstr("\n\r\n\r"
            "H8 Monitor ver " MONITOR_MAJOR_VERSION "\n\r"
            "Kyoto University Mechatronics Creators\n\r"
            "\n\r");

    /* I[g[h */
    if(mon_has_eeprom==1){
        int flag;
        flag=eep_read_byte(EEP_FLAGS);
        if((flag & EEP_FLAGS_AUTOLOAD) != 0){
            hputstr("autoload srec from eeprom.\r\n");
            /* UI[g[hB */
            eep_write_byte(EEP_FLAGS,flag & (~EEP_FLAGS_AUTOLOAD));
            /* [hɐ̂݃tOĐݒ */
            if(eep_readsrec()==0){
                eep_write_byte(EEP_FLAGS,flag);
                hputstr("autoload done.\r\n");
            }
        }
    }

    while (1) {
	hputstr("ready > ");
	hgetstr(str);
	p = str;
	hputstr("\r\n");

	p += strspn(str, TOKENS);
	if (*p == '\0')
	    continue;

	len = strcspn(p, TOKENS);

	if (!strncmp(p, "dump", len) || !strncmp(p, "d", len) ||
	    !strncmp(p, "DUMP", len) || !strncmp(p, "D", len)) {
	    mon_dump_memory(p + len);
	} else if (!strncmp(p, "writemem", len) || !strncmp(p, "w", len) ||
		   !strncmp(p, "WRITEMEM", len) || !strncmp(p, "W", len)) {
	    mon_write_memory(p + len);
	} else if (!strncmp(p, "load", len) || !strncmp(p, "l", len) ||
		   !strncmp(p, "LOAD", len) || !strncmp(p, "L", len)) {
	    mon_load_srecord_file();
	} else if (!strncmp(p, "eeprom", len) || !strncmp(p, "e", len) ||
		   !strncmp(p, "EEPROM", len) || !strncmp(p, "E", len)) {
	    mon_eeprom_mode();
	} else if (!strncmp(p, "go", len) || !strncmp(p, "g", len) ||
		   !strncmp(p, "GO", len) || !strncmp(p, "G", len)) {
	    mon_go();
	} else if (!strncmp(p, "?", len) || !strncmp(p, "h", len) ||
		   !strncmp(p, "help", len) || !strncmp(p, "HELP", len)) {
            mon_help();
	} else if (!strncmp(p, "version", len) || !strncmp(p, "v", len) ||
		   !strncmp(p, "VERSION", len) || !strncmp(p, "V", len)) {
            mon_version();
	} else if (!strncmp(p, "checksum", len) || !strncmp(p, "c", len) ||
		   !strncmp(p, "CHECKSUM", len) || !strncmp(p, "C", len)) {
	    mon_calc_checksum();
	} else if (!strncmp(p, "viewlog", len) || !strncmp(p, "vl", len) ||
		   !strncmp(p, "VIEWLOG", len) || !strncmp(p, "VL", len)) {
	    log_view();
	} else {
	    hputstr("Please enter '?' for help.\n\r");
	}
    }
}

int main(void)
{
    extern void mon_bus_init(void);
    extern void mon_int_init(void);
    extern void mon_sio_init(void);
    extern void mon_reset_init(void);

    mon_bus_init();
    mon_reset_init();
    mon_int_init();
    mon_sio_init();
    monitor_main();
    return 0;
}
